Scriptname NW_AspectScript extends Actor  
{Script for aspects.} 

Quest Property CurrentQuest Auto

VisualEffect Property DragonAbsorbEffect Auto
VisualEffect Property DragonAbsorbManEffect Auto

EffectShader Property DragonHolesFXS Auto
EffectShader Property DragonHolesBitsFXS Auto
EffectShader Property DragonHolesBitsLiteFXS Auto
EffectShader Property DragonPowerAbsorbFXS Auto
EffectShader Property DragonHolesSmokeFXS Auto
EffectShader Property DragonHolesMagicFXS Auto
EffectShader Property DragonHolesLightFXS Auto

ImageSpaceModifier Property DragonPowerAbsorbISM Auto

sound property NPCDragonDeathSequenceFireLPM auto
sound property NPCDragonDeathSequenceWind auto
sound property NPCDragonDeathSequenceExplosion auto
sound property NPCDragonDeathSequenceSmolderLPM auto
sound property UILevelUp auto
sound property QSTWordWallWhisper2DLPSD auto

EffectShader Property GhostFXShader Auto
Explosion Property TransformExplosion Auto
Spell Property TeachForm Auto

ObjectReference ExplosionEffect

Event OnLoad()
	GhostFXShader.Play(Self)
EndEvent

Event OnEnterBleedout()
	Self.SetGhost(true)
	Self.ClearExtraArrows()
	Self.SetRestrained(true)
	Self.SetUnconscious(true)
	
	Self.SetRelationshipRank(Game.GetPlayer(), 3)
	Self.PlaySubGraphAnimation("SkinFadeOut")
	DragonPowerAbsorbISM.Apply()
	DragonPowerAbsorbFXS.Play(Game.GetPlayer())
	
	int soundInstanceFireID = NPCDragonDeathSequenceFireLPM.play(Game.GetPlayer())
	int soundInstanceChantID = QSTWordWallWhisper2DLPSD.play(Game.GetPlayer())
	
	Sound.SetInstanceVolume(soundInstanceChantID, 1)
	; Display dragon absorb effect art. One part on dragon one part on player.
	DragonAbsorbEffect.Play(Self, 8, Game.GetPlayer())
	DragonAbsorbManEffect.Play(Game.GetPlayer(), 8, Self)

	; Sounds for when the wispy particles being to fly at the player.
	NPCDragonDeathSequenceWind.play(Game.GetPlayer()) 
	NPCDragonDeathSequenceExplosion.play(Game.GetPlayer()) 

	Utility.Wait(0.1)
	
	; On man power absorb effect shader.
	DragonPowerAbsorbFXS.Play(Game.GetPlayer())	
	
	Utility.Wait(1)

	;Small bits rising from dragon fx shader.
	DragonHolesBitsLiteFXS.Play(Self)

	Utility.Wait(1)
	;Bigger bits rising from dragon fx shader.
	DragonHolesBitsFXS.Play(Self)

	Utility.Wait(1.0)
	; magic fire fx shader
	DragonHolesMagicFXS.Play(Self)
	DragonHolesMagicFXS.Stop(Self)
	Utility.Wait(0.25)	
	
	;StopDragon bits fxs
	DragonHolesBitsFXS.Stop(Self)
	DragonHolesBitsLiteFXS.Stop(Self)		
	;Stop holes fx shader now that main dragon skin is un-worn
	DragonHolesFXS.Stop(Self)

	Utility.Wait(1.8)

	ExplosionEffect = Self.PlaceAtMe(TransformExplosion)
	Self.SetAlpha(0.0,True)
	GhostFXShader.Stop(Self)
	
	Utility.Wait(2)
	; turn off remaining effect bits and magic leak fxshaders
	Self.DisableNoWait()
	Self.Delete()
	Utility.Wait(2)

	; End sound of dragon carcass bursting into flames.
	Sound.StopInstance(soundInstanceFireID)

	; add lingering smoke and glow to dragon carcass.
	DragonHolesSmokeFXS.Play(Self)	

	; Start sound for smoldering dragon
	int soundInstanceSmolderID = NPCDragonDeathSequenceSmolderLPM.play(Game.GetPlayer()) 

	Utility.Wait(2)

	; Start sound for level up
	int soundInstanceLevelUpID = UILevelUp.play(Game.GetPlayer())
	Sound.SetInstanceVolume(soundInstanceLevelUpID, 1)
	
	; turn off effect shaders for smoldering carcass
	DragonHolesSmokeFXS.Stop(Self)

	; Get rid of art attached to dragon and player showing streaming magic.
	DragonAbsorbEffect.Stop(Self)
	DragonAbsorbManEffect.Stop(Game.GetPlayer())

	Sound.StopInstance(soundInstanceChantID)
	
	Utility.Wait(2)

	;Stop smoldering sound
	Sound.StopInstance(soundInstanceSmolderID)

	Game.GetPlayer().AddSpell(TeachForm)

	;Stop light emitting magic shader on dragon
	DragonHolesLightFXS.Stop(Self)			

	;Stop fx shader on player showing power absorb.	
	DragonPowerAbsorbFXS.Stop(Game.GetPlayer())
	
	Utility.Wait(3)
	
	Sound.StopInstance(soundInstanceLevelUpID)
	
	DragonPowerAbsorbFXS.Stop(Game.GetPlayer())
	ExplosionEffect.DisableNoWait()
	ExplosionEffect.Delete()
	CurrentQuest.SetStage(20)
EndEvent
