Scriptname NW_NaturesCallScript extends activemagiceffect  
{Summon a horde of tree spirits.}

Quest Property ConfigMenu Auto
ActorBase Property TreeSpiritType Auto
Explosion Property SummonPortal Auto
GlobalVariable Property IsSpiritsSummoned Auto
ObjectReference[] Spirits

float AlterationMultiplier
float Alteration
int SizeLimit

Event OnInit()
	If((ConfigMenu as NW_SkiConfigMenu))
		AlterationMultiplier = ((ConfigMenu as NW_SkiConfigMenu).NW_TreeSpiritMultiplier) / 100
	Else
		AlterationMultiplier = 0.08
	EndIf

	Alteration = Game.GetPlayer().GetAV("Alteration")
	
	If(Alteration > 100)
		Alteration = 100
	EndIf
	
	SizeLimit = Math.Ceiling(Alteration * AlterationMultiplier)
	Spirits = new ObjectReference[16]
EndEvent

Event OnEffectStart(Actor akTarget, Actor akCaster)
	If(IsSpiritsSummoned.GetValueInt() == 1)
		Return
	EndIf
	
	int count = 0
	While count < SizeLimit
		Spirits[count] = Game.GetPlayer().PlaceActorAtMe(TreeSpiritType)
		Spirits[count].PlaceAtMe(SummonPortal)
		Spirits[count].Enable()
		count += 1
	EndWhile
	
	IsSpiritsSummoned.SetValueInt(1)
EndEvent

Event OnEffectFinish(Actor akTarget, Actor akCaster)
	int count = 0
	While count < SizeLimit
		Debug.SendAnimationEvent(Spirits[count], "bleedOutStart")
		Spirits[count].PlaceAtMe(SummonPortal)
		Spirits[count].DisableNoWait()
		Spirits[count].Delete()
		count += 1
	EndWhile
	
	IsSpiritsSummoned.SetValueInt(0)
EndEvent