Scriptname NW_TransformScript extends ActiveMagicEffect  
{Transforms the player into an aspect of a creature.}

Quest Property DruidTrackingQuest Auto
Quest Property ConfigMenu Auto

Race Property PolymorphRace Auto

Spell Property RevertForm Auto

Faction Property FriendlyFaction Auto
Faction Property AspectFaction Auto

Spell Property TransformSpell Auto

Spell Property AttachedSpell1 Auto
Spell Property AttachedSpell2 Auto

Spell Property AspectAbility Auto
Perk Property NW_StaggerImmunePerk Auto

Message Property NW_IntroMsg Auto
Message Property NW_OutroMsg Auto

String Property IntroIdle Auto
String Property OutroIdle Auto
Explosion Property ExplosionMorphFX Auto
VisualEffect Property TrailFX Auto
EffectShader Property EffectShaderFX Auto

NW_NaturesWrathHousekeepingScript HousekeepingScript
NW_SkiConfigMenu ConfigMenuScript
Spell EquippedPower

bool hasIntro
bool hasOutro
bool hasAmbient
bool hasCloak

Form[] Gear
Form Equipment
bool HasRightSpell
bool HasLeftSpell

Spell RightSpell
Spell LeftSpell
int ItemTypeRight
int ItemTypeLeft

int z
int e
int i

Function SaveGear(Actor Caster)
	Gear = new Form[40]
	z = 1
	e = 0
	i = 0

	While(i < 40)
		Equipment = Caster.GetWornForm(z)
		If(Equipment)
			Gear[e] = Equipment
			e = e + 1
		EndIf
		z = z * 2
		i = i + 1
	EndWhile

	ItemTypeLeft = Caster.GetEquippedItemType(0)
	ItemTypeRight = Caster.GetEquippedItemType(1)

	If(ItemTypeLeft >= 1 && ItemTypeLeft <= 4)
		Equipment = Caster.GetEquippedWeapon(true)
		Caster.UnequipItem(Equipment, false, true)
		Gear[e] = Equipment
		e = e + 1
	ElseIf(ItemTypeLeft == 9)
		HasLeftSpell = true
		LeftSpell = Caster.GetEquippedSpell(0)
	ElseIf(ItemTypeLeft == 10)
		Gear[e] = Caster.GetEquippedShield()
		e = e + 1
	ElseIf(ItemTypeLeft == 11)
		Gear[e] = Game.GetForm(0x0001D4EC)
		e = e + 1
	EndIf

	If(ItemTypeRight >= 1 && ItemTypeRight <= 8)
		Equipment = Caster.GetEquippedWeapon(false)
		Caster.UnequipItem(Equipment, false, true)
		Gear[e] = Equipment
		e = e + 1
	ElseIf(ItemTypeLeft == 9)
		HasRightSpell = true
		RightSpell = Caster.GetEquippedSpell(1)
	EndIf
EndFunction

Function EquipGear(Actor Caster)
	i = 0
	While(i < e)
		Caster.EquipItem(Gear[i], false, true)
		i = i + 1
	EndWhile

	If(HasRightSpell)
		HasRightSpell = false
		Caster.EquipSpell(RightSpell, 1)
	EndIf

	If(HasLeftSpell)
		HasLeftSpell = false
		Caster.EquipSpell(LeftSpell, 0)
	EndIf	
EndFunction

Function GetOptions()
	ConfigMenuScript = ConfigMenu as NW_SkiConfigMenu
	hasIntro = ConfigMenuScript.NW_IntroAnimEnabled
	hasOutro = ConfigMenuScript.NW_OutroAnimEnabled
	hasAmbient = ConfigMenuScript.NW_AmbientEffectEnabled
	hasCloak = ConfigMenuScript.NW_CloakEffectEnabled
EndFunction

Event OnInit()
	EquippedPower = Game.GetPlayer().GetEquippedSpell(2)
	Game.GetPlayer().UnequipSpell(EquippedPower, 2)
	HousekeepingScript = DruidTrackingQuest as NW_NaturesWrathHousekeepingScript

	If(HousekeepingScript.HasSKSE())
		GetOptions()
	EndIf
EndEvent

Event OnEffectStart(Actor Target, Actor Caster)
	If(hasCloak)
		EffectShaderFX.Stop(Target)
		EffectShaderFX.Play(Target,-1.0)
	EndIf

	HousekeepingScript.StorePlayerRace()

	NW_IntroMsg.Show()
	
	Game.GetPlayer().AddToFaction(FriendlyFaction)
	
	Caster.PlaceAtMe(ExplosionMorphFX)

	Caster.SetRace(PolymorphRace)

	If(hasAmbient)
		TrailFX.Play(Caster, -1)
	EndIf
	
	Game.DisablePlayerControls(abMovement = false, abFighting = false, abCamSwitch = true, abLooking = false, abSneaking = false, abMenu = true, abActivate = true, abJournalTabs = false)
	Game.ForceThirdPerson()
	Game.ShowFirstPersonGeometry(false)
	
	If(hasIntro)
		Debug.SendAnimationEvent(Caster, IntroIdle)
	EndIf
	
	Game.GetPlayer().AddSpell(AspectAbility, false)

	Game.GetPlayer().AddPerk(NW_StaggerImmunePerk)
	
	SaveGear(Caster)
	Caster.UnequipAll()

	If(AttachedSpell1)
		Caster.AddSpell(AttachedSpell1, false)
		Caster.EquipSpell(AttachedSpell1, 0)
	EndIf

	Utility.Wait(1.5)

	Caster.AddSpell(RevertForm, false)
	Caster.EquipSpell(RevertForm, 2)
EndEvent

Event OnEffectFinish(Actor Target, Actor Caster)
	Caster.UnequipSpell(RevertForm, 2)
	Caster.RemoveSpell(RevertForm)

	Game.GetPlayer().RemoveSpell(TransformSpell)

	Game.GetPlayer().SetGhost(true)
	
	Game.GetPlayer().RemovePerk(NW_StaggerImmunePerk)

	NW_OutroMsg.Show()

	Game.GetPlayer().RemoveFromFaction(FriendlyFaction)
	Game.GetPlayer().RemoveSpell(AspectAbility)
	Game.GetPlayer().DispelSpell(AspectAbility)
	
	If(hasOutro)
		Debug.SendAnimationEvent(Caster, OutroIdle)
		Utility.Wait(1)
	EndIf
	
	If(AttachedSpell1)
		Caster.UnequipSpell(AttachedSpell1, 0)
		Caster.RemoveSpell(AttachedSpell1)
		Caster.DispelSpell(AttachedSpell2)
	EndIf
	
	If(hasCloak)
		EffectShaderFX.Stop(Target)
	EndIf
	
	EquipGear(Caster)

	Caster.SetRace(HousekeepingScript.PlayerOriginalRace)
	Caster.PlaceAtMe(ExplosionMorphFX)

	Game.GetPlayer().SetGhost(false)

	If(hasAmbient)
		TrailFX.Stop(Caster)
	EndIf

	Utility.Wait(1.5)

	Game.EnablePlayerControls(abMovement = false, abFighting = false, abCamSwitch = true, abLooking = false, abSneaking = false, abMenu = true, abActivate = true, abJournalTabs = false)
    Game.ShowFirstPersonGeometry(true)

    Game.GetPlayer().EquipSpell(EquippedPower, 2)
EndEvent
