Scriptname NW_TreeSpiritActorScript extends Actor  
{ Tree Spirit Actor Script. }

Spell Property Paralysis Auto
Spell Property NW_SprigganConcentration Auto
Activator Property FXEmptyActivator Auto
ObjectReference CastPoint

Event OnLoad()
	If Self.GetRelationshipRank(Game.GetPlayer()) < 3
		Self.SetRelationshipRank(Game.GetPlayer(), 3)
	EndIf
	If !Self.IsIgnoringFriendlyHits()
		Self.IgnoreFriendlyHits(True)
	EndIf
EndEvent

Event OnCombatStateChanged(Actor akTarget, int aeCombatState)
	If(!akTarget.IsHostileToActor(Game.GetPlayer()) && aeCombatState == 1)
		Self.StopCombat()
		If Self.GetRelationshipRank(akTarget) < 1
			Self.SetRelationshipRank(akTarget, 1)
		EndIf
	EndIf
EndEvent

Event OnHit(ObjectReference akAggressor, Form akSource, Projectile akProjectile, bool abPowerAttack, bool abSneakAttack, bool abBashAttack, bool abHitBlocked)
	If (akAggressor as Actor) && ((akSource as Weapon) || ((akSource as Spell) && (akSource as Spell).IsHostile() && (akSource as Spell) != NW_SprigganConcentration))
		Self.RestoreActorValue("health", Game.GetPlayer().GetActorValue("health") * 0.015)
		Game.GetPlayer().DamageActorValue("health", Game.GetPlayer().GetActorValue("health") * 0.015)
		Game.GetPlayer().DamageActorValue("stamina", Game.GetPlayer().GetActorValue("stamina") * 0.015)
	EndIf
EndEvent
  
Event OnDeath(Actor akKiller)
	CastPoint = Self.placeAtMe(FXEmptyActivator)
	CastPoint.MoveTo(Self, 0, 0, Self.GetHeight() + 40)
	CastPoint.SetAngle(CastPoint.GetAngleX(), CastPoint.GetAngleY(), CastPoint.GetAngleZ() + CastPoint.GetHeadingAngle(akKiller))
	Paralysis.RemoteCast(CastPoint, Self, akKiller)
EndEvent
